package b72_j21ref.c17_inheritance;
/* M:/72_Java/b72_j21ref/c17_inheritance/Reports17.java
 * Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
 */



/*******************************************************************************
 * Knihovní třída {@code Reports17} obsahuje sadu metod sloužících k demonstraci
 * průběhu některých činností při konstrukci objektů a jejich používání.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2023-Summer
 */
public class Reports17
{
//== OTHER NON-PRIVATE CLASS METHODS ===========================================

    /***************************************************************************
     * Metoda pro výpis zprávy konstruktoru o typu konstruovaného objektu
     * spolu s typem aktuálně konstruovaného podobjektu.
     *
     * @param instance Instance výsledného konstruovaného objektu
     * @param cls      Class-objekt třídy volajícího konstruktoru
     */
    public static void constructorReport(Object instance, Class<?> cls)
    {
        Class<?> instanceCls = instance.getClass();
        boolean  topType     = instanceCls.equals(cls);
        String callingClass  = cls        .getSimpleName();
        String instanceClass = instanceCls.getSimpleName();
        String indent        = "                        "
                             .substring(0, callingClass.length()+2);
        System.out.println(callingClass + ": Vytvářím " + instance + "\n"+
                (topType ? ""
                         : indent + "jako rodičovský podobjekt objektu typu " +
                           instanceClass));
    }


    /***************************************************************************
     * Pomocná metoda -- vytiskne argument na standardní výstup
     * a vrátí jej jako funkční hodnotu.
     *
     * @param input Tištěný a vracený objekt
     * @return Argument
     */
    public static String intermezzo(String input)
    {
        System.out.println(input);
        return input;
    }


    /***************************************************************************
     * Vytiskne podpis argumentu na standardní výstup.
     *
     * @param object Tištěný objekt
     */
    public static void println(Object object)
    {
        System.out.println(object);
    }



//##############################################################################
//== CONSTRUCTORS AND FACTORY METHODS ==========================================

    /***************************************************************************
     * Soukromý konstruktor zabraňující vytvoření instance.
     */
    private Reports17()
    {
    }

}
